package com.tofly.toflyServer.utils;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import ch.ethz.ssh2.ChannelCondition;
import ch.ethz.ssh2.Connection;
import ch.ethz.ssh2.StreamGobbler;

public class FileUtil {
	
	
	 public static List<HashMap<String,String>> getSubfolderName(String romoteAddr,String username,
	            String password,String targetFolder) {
	        
		 	List<HashMap<String,String>> result =new  ArrayList<HashMap<String,String>>();
	        
	        try {
	              Connection connection = new Connection(romoteAddr,50922);// 创建一个连接实例
	              connection.connect();// Now connect
	              boolean isAuthenticated = connection.authenticateWithPassword(username, password);//認證
	              //Assert.isTrue(isAuthenticated, "用戶名或密碼錯誤！");
	              ch.ethz.ssh2.Session sess = connection.openSession();// 創建一個會話
	              sess.requestPTY("bash");
	              sess.startShell();
	              InputStream stdout = new StreamGobbler(sess.getStdout());
	              InputStream stderr = new StreamGobbler(sess.getStderr());
	              BufferedReader stdoutReader = new BufferedReader(new InputStreamReader(stdout));
	              BufferedReader stderrReader = new BufferedReader(new InputStreamReader(stderr));
	              //向服务器上输入命令
	              PrintWriter out = new PrintWriter(sess.getStdin());
	              out.println("cd " + targetFolder);//進入日志文件存放的目录
	              out.println("ls -ld *");
	              out.println("exit");
	              out.close();
	              sess.waitForCondition(ChannelCondition.CLOSED|ChannelCondition.EOF | ChannelCondition.EXIT_STATUS,30000);
	              
	             
	              while (true) {
	                  String line = stdoutReader.readLine();
	                  HashMap<String,String> fileMap=new HashMap<String,String>();
	                  if (line == null)
	                      break;
	                  
	                  //取出文件夹那条记录
	                  if(line.contains("drwxr-xr-x")){
	                      //取出正确的文件夹名
//	                      StringBuffer sb = 
//	                              new StringBuffer(line.substring(line.lastIndexOf(" "),line.lastIndexOf("/")));
	                      line = line.substring(line.lastIndexOf(" ")+1,line.length());
	                      fileMap.put("name", line);
	                      fileMap.put("type", "folder");
	                      result.add(fileMap); 
	                  }else if(line.contains("-rw-r--r--")) {
	                	  line = line.substring(line.lastIndexOf(" ")+1,line.length());
	                      fileMap.put("name", line);
	                      fileMap.put("type", "file");
	                      result.add(fileMap); 
	                  }
	              }
	              
	              //关闭连接
	              sess.close();
	              connection.close();
	              stderrReader.close();
	              stdoutReader.close();
	          } catch (IOException e) {
	              e.printStackTrace(System.err);
	              System.exit(2);
	          }
	        return result;
	    }

}
