package com.tofly.toflyServer.utils;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

@Component
@ConfigurationProperties(prefix="system")
public class Props {
	
	public String geoserverUrl;
	public String geoserverUsername;
	public String geoserverPassword;
	
	public String getGeoserverUrl() {
		return geoserverUrl;
	}
	public Props setGeoserverUrl(String geoserverUrl) {
		this.geoserverUrl = geoserverUrl;
		return this;
	}
	public String getGeoserverUsername() {
		return geoserverUsername;
	}
	public Props setGeoserverUsername(String geoserverUsername) {
		this.geoserverUsername = geoserverUsername;
		return this;
	}

	public String getGeoserverPassword() {
		return geoserverPassword;
	}

	public Props setGeoserverPassword(String geoserverPassword) {
		this.geoserverPassword = geoserverPassword;
		return this;
	}
}